#
#  This is version 4.0 7/21/2018
#
import Blender
from Blender import *
from Blender import Draw, BGL
from Blender.Mathutils import Vector
import os,math,struct
import msh_import,msh_export,anm_import,anm_export,tm_preflight_tests,anm_rescale
d2r = math.pi/180.0
scn = Blender.Scene.GetCurrent()
mystring = ""
mymsg = "Ready"
toggle = 0
game_meshes = 'C:/TMBlender/data/meshes'
modified_meshes = 'C:/The Movies/data/meshes'
game_animations = 'C:/TMBlender/data/animations/high'
modified_animations = 'C:/The Movies/data/animations/high'
blender_dir = 'C:/Program Files (x86)/Blender Foundation/Blender'
movies_dir = 'C:/The Movies'
med_folder = 'C:/Program Files (x86)/DCModding/The Movies Editor'
flm_reader_folder = 'C:/Users/Cary Semar/Documents/TheMovies/flmreaderzero'
tmg_exe = 'moviesse.exe'
med_exe = 'med.exe'
flm_exe = 'FlmFileReader.exe'

folders = [game_meshes,
           modified_meshes,
           game_animations,
           modified_animations]

os.chdir(blender_dir)
curdir = os.getcwd()
def bake_prop_animation():
    global mymsg
    mymsg = ''
    scn= Scene.GetCurrent()
    props = Object.Get()
    pen = None
    for prop in props:
        print prop.name,prop.isSelected(),prop.type
        if prop.isSelected():
            pen = prop
            if prop.type == 'Empty':
                pen = prop
    if pen == None:
#        raise ValueError, 'No object selected'
        mymsg = 'No object Selected'
        return
    if pen.type != 'Empty':
#        raise ValueError, 'Object selected is not an Empty'
        mymsg = 'Object selected is not an Empty'
        return
    framecount = Blender.Get('endframe')+1
    pen_rots = []
    pen_locs = []
    for f in range(framecount):
        Blender.Set('curframe',f+1)
        pen_mat = pen.matrixWorld
        pen_rots += [pen_mat.rotationPart().toEuler()]
        pen_locs += [pen_mat.translationPart()]
    pen.clrParent(2)
    print 'Parent cleared'
    for f in range(framecount):
        Blender.Set('curframe',f+1)
        (u,v,w) = pen_rots[f]
        pen.setEuler(d2r*u,d2r*v,d2r*w)
        pen.setLocation(pen_locs[f])
        pen.insertIpoKey(Blender.Object.ROT)
        pen.insertIpoKey(Blender.Object.LOC)                  
    Blender.Set('curframe',1)
    mymsg = 'Script terminated normally'    
def callback_5(filename):
  msh_import.load_msh(filename)
  Draw.Redraw(1)
def callback_6(filename):
  msh_export.save_msh(filename)
  Draw.Redraw(1)
def callback_7(filename):
  anm_import.load_anm(filename)
  Draw.Redraw(1)
def callback_8(filename):
  anm_export.main(filename)
  Draw.Redraw(1)
def callback_9(filename):
  os.chdir(filename)
  Draw.Redraw(1)
def callback_15(filename):
  anm_rescale.main(filename)
  Draw.Redraw(1)
def callback_16(filename):
    scn = Scene.GetCurrent()
    if scn.properties.has_key('ANMHead') == False:
        scn.properties['ANMHead'] = {}
    scn.properties['ANMHead']['Target File'] = filename
    Draw.Redraw(1)
def event(evt, val):    # the function to handle input events
  global mystring, mymsg

  if not val:  # val = 0: it's a key/mbutton release
    if evt in [Draw.LEFTMOUSE, Draw.MIDDLEMOUSE, Draw.RIGHTMOUSE]:
#      mymsg = "You released a mouse button."
      Draw.Redraw(1)
    return

  if evt == Draw.ESCKEY:
    Draw.Exit()                 # exit when user presses ESC
    return

  elif Draw.AKEY <= evt <= Draw.ZKEY: mystring += chr(evt)
  elif evt == Draw.SPACEKEY: mystring += ' '
  elif evt == Draw.BACKSPACEKEY and len(mystring):
    mystring = mystring[:-1]
  else: return # no need to redraw if nothing changed

  Draw.Redraw(1)

def button_event(evt):  # the function to handle Draw Button events
  global mymsg, toggle
  mymsg = ""
  if evt > 0 and evt <= len(folders):
    mymsg = ""
    os.chdir(folders[evt-1])
    Draw.Redraw(1)
  elif evt == 5:
    Blender.Window.FileSelector(callback_5,"Import MSH",'*.msh')
    Draw.Redraw(1)
  elif evt == 6:
    Blender.Window.FileSelector(callback_6,"Export MSH",'*.msh')
    Draw.Redraw(1)
  elif evt == 7:
    Blender.Window.FileSelector(callback_7,"Import ANM",'*.anm')
    Draw.Redraw(1)
  elif evt == 8:
    scn = Scene.GetCurrent()
    if scn.properties.has_key('ANMHead') == False:
        scn.properties['ANMHead'] = {}
    if scn.properties['ANMHead'].has_key('Target File') == False:
        mymsg = 'No target file defined'
    else :
        curdir = os.getcwd()
        anm_export.main(curdir)
#    Blender.Window.FileSelector(callback_8,"Export ANM",'*.anm')
    Draw.Redraw(1)
  elif evt == 9:
    Blender.Window.FileSelector(callback_9,"Select Dir",' ')
    Draw.Redraw(1)
  elif evt == 10:
    tm_preflight_tests.run_tests()
    Draw.Redraw(1)
  elif evt == 11:
    os.chdir(movies_dir)
    os.system(tmg_exe)  # name of movites executable
    Draw.Redraw(1)
  elif evt == 12:
    os.chdir(med_folder)
    os.system(med_exe)  # Movies Editor Executable
    Draw.Redraw(1)
  elif evt == 13:
    os.chdir(flm_reader_folder)
    os.system(flm_exe)  # FlmFileREader executable
    Draw.Redraw(1)
  elif evt == 14:
    bake_prop_animation()
    Draw.Redraw(1)
  elif evt == 15:
    curdir = os.getcwd()
    anm_rescale.main(curdir)
    Draw.Redraw(1)
  elif evt == 16:
      Blender.Window.FileSelector(callback_16,"Target ANM",'*.anm')
def gui():              # the function to draw the screen
    global mystring, mymsg, toggle
    if len(mystring) > 90: mystring = ""
    BGL.glClearColor(.5,.5,.5,1)
    BGL.glClear(BGL.GL_COLOR_BUFFER_BIT)
    BGL.glColor3f(1,1,1)
#  Draw.Toggle("Toggle", 1, 10, 10, 55, 20, toggle,"A toggle button")
    Draw.PushButton("Game Meshes",1, 10, 10, 128, 20, game_meshes)
    Draw.PushButton("Modified Meshes",2, 10, 40, 128, 20, modified_meshes)
    Draw.PushButton("Game Animations ",3,10,70,128,20,game_animations)
    Draw.PushButton("Modified Animations",4,10,100,128,20,modified_animations)
    BGL.glRasterPos2i(15,160)
    Draw.Text("Default Folders",'large')
    BGL.glRasterPos2i(250,160)
    Draw.Text("Functions",'large')
    Draw.PushButton("Import MSH ",5,148,10,128,20,"msh_import")
    Draw.PushButton("Export MSH ",6,148,40,128,20,"msh_export")
    Draw.PushButton("Import ANM  ",7,148,70,128,20,"anm_import")
#    if scn.properties.has_key('ANMHead') == False:
#        scn.properties['ANMHead'] = {}
#    if scn.properties.has_key['ANMHead'].has_key('Target File'):
    if mymsg == 'No target file defined':
        Draw.PushButton("Set Target File ",16,148,100,128,20,"Select ANM Target File")
    else :    
        Draw.PushButton("Export ANM  ",8,148,100,128,20,"anm_export")
    Draw.PushButton("Set CurDir  ",9,10,130,128,20,"Select Current Directory")
    Draw.PushButton("TM Preflight",10,148,130,128,20,"Run TM Preflight")
    Draw.PushButton("The Movies Game",11,286,10,128,20,"Start the game")
    Draw.PushButton("Movies Editor ",12,286,40,128,20,"Start the Movies Editor")
    Draw.PushButton("FLM Reader ",13,286,70,128,20,"Run Flm Reader Zero")
    Draw.PushButton("Bake Prop Animation ",14,286,100,128,20,"Push Button 14")
    Draw.PushButton("Rescale ANM",15,286,130,128,20,"Rescale an Animation")
    BGL.glRasterPos2i(10,240)
    Draw.Text('TMG GUI Version 4.1')
    BGL.glRasterPos2i(10, 220)
    Draw.Text("Press ESC to leave.")

    BGL.glRasterPos2i(10,180)
    curdir = os.getcwd()
    Draw.Text('Current Directory:'+curdir)
    BGL.glColor3f(1,0,0)
    BGL.glRasterPos2i(10, 200)
    Draw.Text(mymsg)


Draw.Register(gui, event, button_event)  # registering the 3 callbacks
